VERSION 5.00
Begin VB.Form frmSenderBoy 
   Caption         =   "Send Me a Message"
   ClientHeight    =   4530
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7890
   LinkTopic       =   "Form1"
   ScaleHeight     =   4530
   ScaleWidth      =   7890
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdScanQueues 
      Caption         =   "Scan for Public Queues"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   3960
      Width           =   7575
   End
   Begin VB.ListBox lstQueues 
      Height          =   1230
      Left            =   120
      TabIndex        =   5
      Top             =   2640
      Width           =   7575
   End
   Begin VB.ListBox lstResponesMsg 
      Height          =   1620
      Left            =   3360
      TabIndex        =   4
      Top             =   360
      Width           =   4335
   End
   Begin VB.ListBox lstRequestMsg 
      Height          =   1620
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   3135
   End
   Begin VB.CommandButton cmdSendMessage 
      Caption         =   "Send a Standard Message"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   2040
      Width           =   7575
   End
   Begin VB.Label Label2 
      Caption         =   "Response Received"
      Height          =   255
      Left            =   3360
      TabIndex        =   3
      Top             =   120
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Message Sent Information"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "frmSenderBoy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==========================================================
'   Compuware, NuMega Lab
'
'   Microsoft Windows DNA 2000
'   'Under the Hood' Series
'
'   'Using MSMQ in a Distributed Application'
'
'==========================================================
Option Explicit

'   we don't want to tie up the main thread waiting for a return
'   by using events we can continue our work and the event will be raised when a message arrives
Private WithEvents qevtRecEvents As MSMQEvent
Attribute qevtRecEvents.VB_VarHelpID = -1

Private m_oRequestQueueInfo     As MSMQQueueInfo
Private m_oResponseQueueInfo    As MSMQQueueInfo

Private m_oRequestQueue     As MSMQQueue
Private m_oResponseQueue    As MSMQQueue
Private m_lMsgCount         As Long

Private Sub cmdScanQueues_Click()
    Dim oQuery As MSMQQuery
    Dim oQInfos As MSMQQueueInfos
    Dim oQInfo As MSMQQueueInfo
    
    Set oQuery = New MSMQQuery
    Set oQInfos = oQuery.LookupQueue

    oQInfos.Reset
    Set oQInfo = oQInfos.Next
    lstQueues.AddItem oQInfo.QueueGuid & " : " & oQInfo.PathName
    Do While Not (oQInfo Is Nothing)
        Set oQInfo = oQInfos.Next
        If Not oQInfo Is Nothing Then
            lstQueues.AddItem oQInfo.QueueGuid & " : " & oQInfo.PathName
        End If
    Loop
End Sub

Private Sub cmdSendMessage_Click()
    Dim oMsgQueue   As MSMQQueue
    Dim oMsg        As MSMQMessage
    
    '   Create a new message object
    Set oMsg = New MSMQMessage
    
    '   increment our message counter
    m_lMsgCount = m_lMsgCount + 1
    
    '   Create the message to be sent
    oMsg.Body = "This message sent courtesy of Compuware/NuMega"
    oMsg.Body = oMsg.Label & "Sent message " & CStr(m_lMsgCount) & " at " & Format(Now, "HH:MM:SS AM/PM")
    oMsg.Label = "Test message #" & CStr(m_lMsgCount) & " sent at " & Format(Now, "HH:MM:SS AM/PM")
    
    '   Tell the receiver which queue to respond to
    Set oMsg.ResponseQueueInfo = m_oResponseQueueInfo
    
    '   Send the message, tell the queue manager that this is a single message
    oMsg.Send m_oRequestQueue
  
    Me.lstRequestMsg.AddItem oMsg.Label

End Sub

Private Sub Form_Load()
    Dim oQueueInfo As MSMQQueueInfo
    
    '  Create the test queue
    Set m_oRequestQueueInfo = CreateMSMQQueue(".\vbcRequestQueue", "Send to Queue")
    Set m_oRequestQueue = m_oRequestQueueInfo.Open(Access:=MQ_SEND_ACCESS, ShareMode:=MQ_DENY_NONE)
    
    '   create the response queue
    CreateMSMQQueue ".\private$\vbcResponseQueue", "Private Response Queue"
    Set m_oResponseQueueInfo = New MSMQQueueInfo
    m_oResponseQueueInfo.PathName = ".\private$\vbcResponseQueue"
    m_oResponseQueueInfo.Refresh
    Set m_oResponseQueue = m_oResponseQueueInfo.Open(Access:=MQ_RECEIVE_ACCESS, ShareMode:=MQ_DENY_NONE)

    '   we want to monitor events from this queue so set up an event sink
    Set qevtRecEvents = New MSMQEvent
    Me.Refresh
    m_oResponseQueue.EnableNotification qevtRecEvents
    
End Sub

Private Sub OpenResponseQueue(strRequestQueuePath As String)
  Dim oQueueInfo    As MSMQQueueInfo
  Dim oQueue        As MSMQQueue
  
  Set oQueueInfo = New MSMQQueueInfo
  
  oQueueInfo.PathName = strRequestQueuePath
  Set oQueue = oQueueInfo.Open(MQ_RECEIVE_ACCESS, MQ_DENY_RECEIVE_SHARE)
  Set qevtRecEvents = New MSMQEvent
  Me.Refresh
  oQueue.EnableNotification qevtRecEvents

End Sub


Private Sub qevtRecEvents_Arrived(ByVal Queue As Object, ByVal Cursor As Long)
    Dim oMsg    As MSMQMessage
    Dim oQueue  As MSMQQueue
    
    Set oQueue = Queue
    Set oMsg = oQueue.Receive(ReceiveTimeout:=0)
    lstResponesMsg.AddItem oMsg.Label
    
    oQueue.EnableNotification qevtRecEvents
End Sub
